<template>
  <div class="dashboard-agent-customers-page pt-3 pb-5">
    <h1 class="page-title">Customers History</h1>
    <div class="mt-3">
      <!-- <div class="d-flex justify-content-end">
        <button class="btn btn-primary">Download Statement</button>
      </div> -->
      <div class="my-3">
        <!-- <div
          class="d-flex flex-wrap align-items-center justify-content-between"
        >
          <div class="d-block my-2">
            <div class="form-group">
              <label class="mb-2">Account From:</label>
              <select
                v-model="form.accountFrom"
                class="form-select"
                v-validate="'required'"
                name="Account From"
              >
                <option
                  v-for="(account, i) in accounts"
                  :key="i"
                  :value="account"
                >
                  {{ `${account.AccountType} - ${account.AccountNumber}` }}
                </option>
              </select>
              <div
                v-show="verrors.has('Account From')"
                class="invalid-feedback"
              >
                {{ verrors.first('Account From') }}
              </div>
            </div>
          </div>
          <div class="d-block my-2">
            <label>Start Date</label>
            <VueDatePicker v-model="startDate"></VueDatePicker>
          </div>
          <div class="d-block my-2">
            <label>End Date</label>
            <VueDatePicker v-model="endDate"></VueDatePicker>
          </div>
          <div class="d-block my-2">
            <vs-button
              :loading="form.active"
              @click="filtercustomers(1, 10)"
            >
              Filter
            </vs-button>
          </div>
          <div class="d-block my-2">
            <vs-button :loading="form.active" @click="generateAccountStatement">
              Generate account Statement
            </vs-button>
          </div>
        </div> -->
      </div>
      <div class="row mt-3">
        <div class="col-sm-12 col-12">
          <div
            ref="content"
            class="tab-table-container table-responsive position-relative"
          >
            <table class="table table-borderless">
              <thead>
                <tr>
                  <th
                    v-for="(head, i) in tableHead"
                    :key="i"
                    class="fw-bold border-bottom"
                  >
                    {{ head }}
                  </th>
                </tr>
              </thead>

              <tbody>
                <tr v-for="(customer, i) in customers" :key="i">
                  <td>
                    <p class="text-muted m-0">ID : {{ customer.id }}</p>
                  </td>
                  <td>
                    <div class="d-flex align-items-center">
                      <vs-avatar circle>
                        <template #text>{{
                          `${customer.firstName[0]}${customer.surname[0]}`
                        }}</template>
                      </vs-avatar>
                      <div class="ms-2">
                        {{ `${customer.firstName} ${customer.surname}` }}
                      </div>
                    </div>
                  </td>
                  <td>
                    <p class="m-0">{{ customer.email }}</p>
                    <p class="m-0">{{ customer.phoneNumber }}</p>
                  </td>
                  <td>{{ customer.city }}</td>
                  <td>{{ customer.channel }}</td>
                  <td>
                    <div class="active-icon">Active</div>
                  </td>
                  <td>{{ customer.createdAt | formatDate }}</td>
                </tr>
              </tbody>
            </table>
            <div
              v-if="!customers.length && !contentLoading"
              class="text-center my-3"
            >
              <h3>No Customer History</h3>
            </div>
            <vs-pagination
              v-model="page"
              :length="totalPages"
              @click="fetchData(page)"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// import { VueDatePicker } from '@mathieustan/vue-datepicker'
// import '@mathieustan/vue-datepicker/dist/vue-datepicker.min.css'

export default {
  // components: { VueDatePicker },
  layout: 'dashboard',
  // async asyncData({ $axios }) {
  //   const userAccounts = await $axios.$get('/user/accounts')
  //   const banks = await $axios.$get('/transaction/banks')
  //   // console.log(userAccounts.headers)
  //   return {
  //     accounts: userAccounts.payload,
  //     banks: banks.payload.banks,
  //   }
  // },
  data: () => ({
    date: {
      from: new Date(),
    },
    form: {
      active: false,
    },
    customerProfile: {},
    tableHead: ['ID', 'Name', 'Info', 'City', 'Channel', 'Status', 'Joined'],
    contentLoading: false,
    customers: [],
    page: 1,
    perPage: 10,
    totalPages: 1,
  }),
  watch: {
    page(value) {
      this.fetchData(value, this.perPage)
    },
  },
  mounted() {
    this.fetchData(this.page, this.perPage)
  },
  methods: {
    async fetchData(page, perPage) {
      const loading = this.$vs.loading({
        target: this.$refs.content,
        color: 'primary',
      })
      try {
        this.contentLoading = true
        const { payload } = await this.$axios.$get(
          `/agent/accounts/registered?page=${page}&limit=${perPage}`
        )
        loading.close()
        console.log(payload)
        this.customers = payload.data
        this.contentLoading = false
        this.totalPages = payload.totalPages
      } catch (error) {
        loading.close()
        this.contentLoading = false
      }
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-agent-customers-page {
  .customers-details-card {
    background: #ffffff;
    border-radius: 20px;
    min-height: 300px;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  table {
    th {
      background: rgb(241, 237, 229);
      padding: 20px;
    }
    td {
      padding: 20px;
    }
    th:first-child {
      border-radius: 20px 0px 0px 0px;
    }

    th:last-child {
      border-radius: 0px 20px 0px 0px;
    }
  }
}
</style>
